#!/bin/bash


if [ "`which python`" = "" ] ; then echo you need python2 ; exit ; fi
if [ "`python --version 2>&1 | awk ' { print $2 } ' | cut -c1`" != "2" ] ; then echo python version 2 is required ; exit ; fi

local=`pwd`
listecas="ARMCU/REF RICO/REF SANDU/REF AYOTTE/05WC AYOTTE/24SC"
listecas="ARMCU/REF RICO/REF SANDU/REF"
listpdf=""


OUT=PYTHON
mkdir -p $OUT

for cas in $listecas ; do
   main=`echo $cas | cut -d/ -f1` ; sub=`echo $cas | cut -d/ -f2`
   case $main in
       AYOTTE) vars=theta ;;
       *) vars="qv rneb theta"
   esac
   for var in $vars ; do
       echo main $main sub $sub
       python trace_sens_LES.py ${var} ${main} ${sub}
       #display profil_${cas}_${var}_*.png
       out=`basename profil_${main}_${sub}_${var}_*.png .png`
       mv $out.png $OUT/
       convert $OUT/$out.png $OUT/$out.pdf
       listpdf="$listpdf $OUT/$out.pdf"
   done
done
pdfjam $listpdf --outfile $OUT/all.pdf --nup 3x3
evince $OUT/all.pdf
